=== modified file 'client/Makefile.am'
--- client/Makefile.am	2009-02-18 22:06:40 +0000
+++ client/Makefile.am	2009-03-12 20:16:13 +0000
@@ -21,8 +21,7 @@
 			$(LIBINTL) $(LIBZ) 
 
 
-noinst_HEADERS =	completion_hash.h \
-			my_readline.h \
+noinst_HEADERS =	my_readline.h \
 			client_priv.h \
 			errname.h
 
@@ -36,7 +35,7 @@
 				drizzletest \
 				drizzleslap
 
-drizzle_SOURCES=		drizzle.cc readline.cc completion_hash.cc
+drizzle_SOURCES=		drizzle.cc readline.cc 
 drizzle_LDADD=			${LDADD} ${READLINE_LIBS}
 drizzle_CXXFLAGS =		${AM_CXXFLAGS} ${W_EXCEPTIONS} 
 

=== removed file 'client/completion_hash.cc'
--- client/completion_hash.cc	2009-02-20 22:48:37 +0000
+++ client/completion_hash.cc	1970-01-01 00:00:00 +0000
@@ -1,224 +0,0 @@
-/* Copyright (C) 2000 MySQL AB
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; version 2 of the License.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
-
-/* Quick & light hash implementation for tab completion purposes
- *
- * by  Andi Gutmans <andi@zend.com>
- * and Zeev Suraski <zeev@zend.com>
- * Small portability changes by Monty.
- */
-
-#include "client_priv.h"
-#include <mystrings/m_string.h>
-#include "completion_hash.h"
-
-uint32_t hashpjw(const char *arKey, uint32_t nKeyLength)
-{
-  uint32_t h = 0, g, i;
-
-  for (i = 0; i < nKeyLength; i++) {
-    h = (h << 4) + arKey[i];
-    if ((g = (h & 0xF0000000))) {
-      h = h ^ (g >> 24);
-      h = h ^ g;
-    }
-  }
-  return h;
-}
-
-int completion_hash_init(HashTable *ht, uint32_t nSize)
-{
-  ht->arBuckets = (Bucket **) malloc(nSize* sizeof(Bucket *));
-  memset(ht->arBuckets, 0, nSize* sizeof(Bucket *));
-
-  if (!ht->arBuckets)
-  {
-    ht->initialized = 0;
-    return FAILURE;
-  }
-  init_alloc_root(&ht->mem_root, 8192, 0);
-  ht->pHashFunction = hashpjw;
-  ht->nTableSize = nSize;
-  ht->initialized = 1;
-  return SUCCESS;
-}
-
-
-int completion_hash_update(HashTable *ht, char *arKey, uint32_t nKeyLength,
-			   char *str)
-{
-  uint32_t h, nIndex;
-
-  Bucket *p;
-
-  h = ht->pHashFunction(arKey, nKeyLength);
-  nIndex = h % ht->nTableSize;
-
-  if (nKeyLength <= 0) {
-    return FAILURE;
-  }
-  p = ht->arBuckets[nIndex];
-  while (p)
-  {
-    if ((p->h == h) && (p->nKeyLength == nKeyLength)) {
-      if (!memcmp(p->arKey, arKey, nKeyLength)) {
-	entry *n;
-
-	if (!(n = (entry *) alloc_root(&ht->mem_root,sizeof(entry))))
-          return FAILURE;
-	n->pNext = p->pData;
-	n->str = str;
-	p->pData = n;
-	p->count++;
-
-	return SUCCESS;
-      }
-    }
-    p = p->pNext;
-  }
-
-  if (!(p = (Bucket *) alloc_root(&ht->mem_root, sizeof(Bucket))))
-    return FAILURE;
-
-  p->arKey = arKey;
-  p->nKeyLength = nKeyLength;
-  p->h = h;
-
-  if (!(p->pData = (entry*) alloc_root(&ht->mem_root, sizeof(entry))))
-    return FAILURE;
-
-  p->pData->str = str;
-  p->pData->pNext = 0;
-  p->count = 1;
-
-  p->pNext = ht->arBuckets[nIndex];
-  ht->arBuckets[nIndex] = p;
-
-  return SUCCESS;
-}
-
-static Bucket *completion_hash_find(HashTable *ht, const char *arKey,
-				    uint32_t nKeyLength)
-{
-  uint32_t h, nIndex;
-  Bucket *p;
-
-  h = ht->pHashFunction(arKey, nKeyLength);
-  nIndex = h % ht->nTableSize;
-
-  p = ht->arBuckets[nIndex];
-  while (p)
-  {
-    if ((p->h == h) && (p->nKeyLength == nKeyLength)) {
-      if (!memcmp(p->arKey, arKey, nKeyLength)) {
-	return p;
-      }
-    }
-    p = p->pNext;
-  }
-  return (Bucket*) 0;
-}
-
-
-int completion_hash_exists(HashTable *ht, char *arKey, uint32_t nKeyLength)
-{
-  uint32_t h, nIndex;
-  Bucket *p;
-
-  h = ht->pHashFunction(arKey, nKeyLength);
-  nIndex = h % ht->nTableSize;
-
-  p = ht->arBuckets[nIndex];
-  while (p)
-  {
-    if ((p->h == h) && (p->nKeyLength == nKeyLength))
-    {
-      if (!strcmp(p->arKey, arKey)) {
-	return 1;
-      }
-    }
-    p = p->pNext;
-  }
-  return 0;
-}
-
-Bucket *find_all_matches(HashTable *ht, const char *str, uint32_t length,
-			 uint32_t *res_length)
-{
-  Bucket *b;
-
-  b = completion_hash_find(ht,str,length);
-  if (!b) {
-    *res_length = 0;
-    return (Bucket*) 0;
-  } else {
-    *res_length = length;
-    return b;
-  }
-}
-
-Bucket *find_longest_match(HashTable *ht, char *str, uint32_t length,
-			   uint32_t *res_length)
-{
-  Bucket *b,*return_b;
-  char *s;
-  uint32_t count;
-  uint32_t lm;
-
-  b = completion_hash_find(ht,str,length);
-  if (!b) {
-    *res_length = 0;
-    return (Bucket*) 0;
-  }
-
-  count = b->count;
-  lm = length;
-  s = b->pData->str;
-
-  return_b = b;
-  while (s[lm]!=0 && (b=completion_hash_find(ht,s,lm+1))) {
-    if (b->count<count) {
-      *res_length=lm;
-      return return_b;
-    }
-    return_b=b;
-    lm++;
-  }
-  *res_length=lm;
-  return return_b;
-}
-
-
-void completion_hash_clean(HashTable *ht)
-{
-  free_root(&ht->mem_root,MYF(0));
-  memset(ht->arBuckets, 0, ht->nTableSize*sizeof(Bucket *));
-}
-
-
-void completion_hash_free(HashTable *ht)
-{
-  completion_hash_clean(ht);
-  free(ht->arBuckets);
-}
-
-
-void add_word(HashTable *ht,char *str)
-{
-  int i;
-  char *pos=str;
-  for (i=1; *pos; i++, pos++)
-    completion_hash_update(ht, str, i, str);
-}

=== removed file 'client/completion_hash.h'
--- client/completion_hash.h	2009-02-20 22:48:37 +0000
+++ client/completion_hash.h	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-/* Copyright (C) 2000-2002 MySQL AB
-
-   This library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Library General Public
-   License as published by the Free Software Foundation; version 2
-   of the License.
-
-   This library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Library General Public License for more details.
-
-   You should have received a copy of the GNU Library General Public
-   License along with this library; if not, write to the Free
-   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
-   MA 02111-1307, USA */
-
-#ifndef _HASH_
-#define _HASH_
-
-#define SUCCESS 0
-#define FAILURE 1
-
-#include <sys/types.h>
-#include <mysys/my_sys.h>
-
-typedef struct _entry {
-	char *str;
-	struct _entry *pNext;
-} entry;
-
-typedef struct bucket
-{
-  uint32_t h;					/* Used for numeric indexing */
-  char *arKey;
-  uint32_t nKeyLength;
-  uint32_t count;
-  entry *pData;
-  struct bucket *pNext;
-} Bucket;
-
-typedef struct hashtable {
-  uint32_t nTableSize;
-  uint32_t initialized;
-  MEM_ROOT mem_root;
-  uint(*pHashFunction) (const char *arKey, uint32_t nKeyLength);
-  Bucket **arBuckets;
-} HashTable;
-
-extern int completion_hash_init(HashTable *ht, uint32_t nSize);
-extern int completion_hash_update(HashTable *ht, char *arKey, uint32_t nKeyLength, char *str);
-extern int hash_exists(HashTable *ht, char *arKey);
-extern Bucket *find_all_matches(HashTable *ht, const char *str, uint32_t length, uint32_t *res_length);
-extern Bucket *find_longest_match(HashTable *ht, char *str, uint32_t length, uint32_t *res_length);
-extern void add_word(HashTable *ht,char *str);
-extern void completion_hash_clean(HashTable *ht);
-extern int completion_hash_exists(HashTable *ht, char *arKey, uint32_t nKeyLength);
-extern void completion_hash_free(HashTable *ht);
-
-uint32_t hashpjw(const char *arKey, uint32_t nKeyLength);
-
-#endif /* _HASH_ */

=== modified file 'client/drizzle.cc'
--- client/drizzle.cc	2009-03-10 06:49:18 +0000
+++ client/drizzle.cc	2009-03-12 20:16:13 +0000
@@ -125,7 +125,9 @@
 #define vidattr(A) {}      // Can't get this to work
 #endif
 
-#include "completion_hash.h"
+#include <iostream>
+#include <functional>
+#include <map>
 
 using namespace std;
 
@@ -149,7 +151,8 @@
 } STATUS;
 
 
-static HashTable ht;
+static map<string, string>::iterator completion_iter;
+static map<string, string> completion_map;
 static char **defaults_argv;
 
 enum enum_info_type { INFO_INFO,INFO_ERROR,INFO_RESULT};
@@ -197,7 +200,6 @@
 static char default_pager[FN_REFLEN];
 static char pager[FN_REFLEN], outfile[FN_REFLEN];
 static FILE *PAGER, *OUTFILE;
-static MEM_ROOT hash_mem_root;
 static uint32_t prompt_counter;
 static char delimiter[16]= DEFAULT_DELIMITER;
 static uint32_t delimiter_length= 1;
@@ -1095,8 +1097,6 @@
     my_end(0);
     exit(1);
   }
-  completion_hash_init(&ht, 128);
-  init_alloc_root(&hash_mem_root, 16384, 0);
   memset(&drizzle, 0, sizeof(drizzle));
   if (sql_connect(current_host,current_db,current_user,opt_password,
                   opt_silent))
@@ -1193,8 +1193,6 @@
       my_rename(histfile_tmp, histfile, MYF(MY_WME));
   }
   batch_readline_end(status.line_buff);
-  completion_hash_free(&ht);
-  free_root(&hash_mem_root,MYF(0));
 
   if (sig >= 0)
     put_info(sig ? _("Aborted") : _("Bye"), INFO_RESULT,0,0);
@@ -2221,86 +2219,69 @@
     return (char**) 0;
 }
 
+inline string lower_string(const string &from_string)
+{
+  string to_string= from_string;
+  transform(to_string.begin(), to_string.end(),
+            to_string.begin(), ::tolower);
+  return to_string;
+}
+
+class CompletionMatch :
+  public unary_function<const string&, bool>
+{
+  string match_text; 
+public:
+  CompletionMatch(string text) : match_text(text)
+  {
+    transform(match_text.begin(), match_text.end(),
+              match_text.begin(), ::tolower);
+  }
+  inline bool operator() (const pair<string,string> &match_against) const
+  {
+    string sub_match=
+      lower_string(match_against.first.substr(0,match_text.size()));
+    return (sub_match == match_text);
+/*(cout << "Matching " << match_text << " against " << match_against.first <<end;
+    if (match_text.compare(0, match_text.size(),
+                           match_against.first, 0,
+                           match_text.size()) == 0)
+      return true;
+    return false; */
+  }
+};
+
+
+
 extern "C"
-char *new_command_generator(const char *text,int state)
+char *new_command_generator(const char *text, int state)
 {
-  static int textlen;
-  char *ptr;
-  static Bucket *b;
-  static entry *e;
-  static uint32_t i;
 
   if (!state)
-    textlen=(uint32_t) strlen(text);
-
-  if (textlen>0)
-  {            /* lookup in the hash */
-    if (!state)
-    {
-      uint32_t len;
-
-      b = find_all_matches(&ht,text,(uint32_t) strlen(text),&len);
-      if (!b)
-        return NULL;
-      e = b->pData;
-    }
-
-    if (e)
-    {
-      ptr= strdup(e->str);
-      e = e->pNext;
-      return ptr;
-    }
-  }
-  else
-  { /* traverse the entire hash, ugly but works */
-
-    if (!state)
-    {
-      /* find the first used bucket */
-      for (i=0 ; i < ht.nTableSize ; i++)
-      {
-        if (ht.arBuckets[i])
-        {
-          b = ht.arBuckets[i];
-          e = b->pData;
-          break;
-        }
-      }
-    }
-    ptr= NULL;
-    while (e && !ptr)
-    {          /* find valid entry in bucket */
-      if ((uint32_t) strlen(e->str) == b->nKeyLength)
-        ptr = strdup(e->str);
-      /* find the next used entry */
-      e = e->pNext;
-      if (!e)
-      { /* find the next used bucket */
-        b = b->pNext;
-        if (!b)
-        {
-          for (i++ ; i<ht.nTableSize; i++)
-          {
-            if (ht.arBuckets[i])
-            {
-              b = ht.arBuckets[i];
-              e = b->pData;
-              break;
-            }
-          }
-        }
-        else
-          e = b->pData;
-      }
-    }
-    if (ptr)
-      return ptr;
-  }
-  return NULL;
+  {
+cout << "trying to find: " << text << endl;
+    string match_text(text);
+    if (match_text.size() == 0)
+    {
+/*cout << "doing the big one " << endl;
+      for(completion_iter= completion_map.begin();
+          completion_iter!= completion_map.end();
+          completion_iter++)
+cout << "SET CONTAINS: " << (*completion_iter).second << endl; */
+      completion_iter= completion_map.begin();
+    }
+    else
+      completion_iter= find_if(completion_map.begin(), completion_map.end(),
+                               CompletionMatch(match_text));
+  }
+  if (completion_iter == completion_map.end())
+    return NULL;
+  char *result= (char *)malloc((*completion_iter).second.size()+1);
+  strcpy(result, (*completion_iter).second.c_str());
+  completion_iter++;
+  return result;
 }
 
-
 /* Build up the completion hash */
 
 static void build_completion_hash(bool rehash, bool write_info)
@@ -2308,11 +2289,9 @@
   COMMANDS *cmd=commands;
   DRIZZLE_RES *databases=0,*tables=0;
   DRIZZLE_RES *fields;
-  static char ***field_names= 0;
   DRIZZLE_ROW database_row,table_row;
   DRIZZLE_FIELD *sql_field;
-  char buf[NAME_LEN*2+2];     // table name plus field name plus 2
-  int i,j,num_fields;
+  string tmp_str, tmp_str_lower;
 
 
   if (status.batch || quick || !current_db)
@@ -2320,15 +2299,13 @@
   if (!rehash)
     return;
 
-  /* Free old used memory */
-  if (field_names)
-    field_names=0;
-  completion_hash_clean(&ht);
-  free_root(&hash_mem_root,MYF(0));
+  completion_map.clear();
 
   /* hash this file's known subset of SQL commands */
   while (cmd->name) {
-    add_word(&ht,(char*) cmd->name);
+    tmp_str= cmd->name;
+    tmp_str_lower= lower_string(tmp_str);
+    completion_map[tmp_str_lower]= tmp_str;
     cmd++;
   }
 
@@ -2343,9 +2320,9 @@
     {
       while ((database_row=drizzleclient_fetch_row(databases)))
       {
-        char *str=strdup_root(&hash_mem_root, (char*) database_row[0]);
-        if (str)
-          add_word(&ht,(char*) str);
+        tmp_str= database_row[0];
+        tmp_str_lower= lower_string(tmp_str);
+        completion_map[tmp_str_lower]= tmp_str;
       }
       drizzleclient_free_result(databases);
     }
@@ -2365,10 +2342,9 @@
       }
       while ((table_row=drizzleclient_fetch_row(tables)))
       {
-        char *str=strdup_root(&hash_mem_root, (char*) table_row[0]);
-        if (str &&
-            !completion_hash_exists(&ht,(char*) str, (uint32_t) strlen(str)))
-          add_word(&ht,str);
+        tmp_str= table_row[0];
+        tmp_str_lower= lower_string(tmp_str);
+        completion_map[tmp_str_lower]= tmp_str;
       }
     }
   }
@@ -2379,13 +2355,7 @@
     return;
   }
   drizzleclient_data_seek(tables,0);
-  if (!(field_names= (char ***) alloc_root(&hash_mem_root,sizeof(char **) *
-                                           (uint32_t) (drizzleclient_num_rows(tables)+1))))
-  {
-    drizzleclient_free_result(tables);
-    return;
-  }
-  i=0;
+
   while ((table_row=drizzleclient_fetch_row(tables)))
   {
     string query;
@@ -2399,39 +2369,25 @@
       fields= drizzleclient_store_result(&drizzle);
       if (fields) 
       {
-        num_fields=drizzleclient_num_fields(fields);
-        if (!(field_names[i] = (char **) alloc_root(&hash_mem_root,
-                                                    sizeof(char *) *
-                                                    (num_fields*2+1))))
-        {
-          drizzleclient_free_result(fields);
-          break;
-        }
-        field_names[i][num_fields*2]= '\0';
-        j= 0;
         while ((sql_field=drizzleclient_fetch_field(fields)))
         {
-          sprintf(buf,"%.64s.%.64s",table_row[0],sql_field->name);
-          field_names[i][j] = strdup_root(&hash_mem_root,buf);
-          add_word(&ht,field_names[i][j]);
-          field_names[i][num_fields+j] = strdup_root(&hash_mem_root,
-                                                     sql_field->name);
-          if (!completion_hash_exists(&ht,field_names[i][num_fields+j],
-                                      (uint32_t) strlen(field_names[i][num_fields+j])))
-            add_word(&ht,field_names[i][num_fields+j]);
-          j++;
+          tmp_str=table_row[0];
+          tmp_str.append(".");
+          tmp_str.append(sql_field->name);
+          tmp_str_lower= lower_string(tmp_str);
+          completion_map[tmp_str_lower]= tmp_str;
+
+          tmp_str=sql_field->name;
+          tmp_str_lower= lower_string(tmp_str);
+          completion_map[tmp_str_lower]= tmp_str;
+
         }
         drizzleclient_free_result(fields);
       }
     }
-    else
-      field_names[i]= 0;
-
-    i++;
   }
   drizzleclient_free_result(tables);
-  field_names[i]=0;        // End pointer
-  return;
+  completion_iter= completion_map.begin();
 }
 
 /* for gnu readline */

